<template>
  <div>
    <div class="row">
      <div class="col-md-12" v-if="filter.filters">
        <SearchFilter :filter="filter" style="background-color:#363636;"></SearchFilter>
      </div>
    </div>

    <div class="custom-container">
      <div class="row">
        <div class="col-sm-12 col-md-9">
          <div class="row">
          <div class="col-6">
            <div v-if="totalJobs" style="color: black;margin-top: 30px;">
            {{totalJobs}} results found for "<span style="color:#EF6363">{{query}}</span>"
            </div>
            <div v-else style="color: black; margin-top: 30px; margin-bottom: 30px;margin-left:15px">
              0 result found for "<span style="color:#EF6363">{{query}}</span>"
            </div>
          </div>
          
          <div v-if="totalJobs" class="col-6">

            <button v-if="user.role_id == 1" v-on:click="goToCompare" class="position position1 btncoloropen comparecount">
            Compare Now ({{ totalCompare.length }})
            </button>
            
            <button v-on:click="filter.filters = !filter.filters"  v-if="filter.filters"  class="position position1 btncolorclose">
            Close Filters
            </button>
            
            <button v-on:click="filter.filters = !filter.filters" v-else class="position position1 btncoloropen">
            Filter Result
            </button>
            <div style="margin-top:30px">
             <span v-on:click="isHiddenSort = !isHiddenSort" class="sort-btn">Sort By: <a class="sort-link">{{sortLabel}}</a></span>
            </div>
            <div class="form-control category2-options toogle-div" v-if="!isHiddenSort" style="z-index:20;">
                  <ul>
                    <li class="categry2-options-li">
                      <input
                        class="mr-2 leading-tight"
                        v-model="sortStatus"
                        type="radio"
                        checked
                        value=""
                      />Relevance
                    </li>
                    <li class="categry2-options-li">
                      <input
                        class="mr-2 leading-tight"
                        v-model="sortStatus"
                        type="radio"
                        value="last-modified"
                      />Last Modified
                    </li>
                    <li class="categry2-options-li">
                      <input
                        class="mr-2 leading-tight"
                        v-model="sortStatus"
                        type="radio"
                        value="job-title-asc"
                      />Job Title (A to Z)
                    </li>
                    <li class="categry2-options-li">
                      <input
                        class="mr-2 leading-tight"
                        v-model="sortStatus"
                        type="radio"
                        value="job-title-desc"
                      />Job Title (Z to A)
                    </li>
                    <li class="categry2-options-li">
                      <input
                        class="mr-2 leading-tight"
                        v-model="sortStatus"
                        type="radio"
                        value="base-rate-asc"
                      />Billing Rate (Low to High)
                    </li>
                    <li class="categry2-options-li">
                      <input
                        class="mr-2 leading-tight"
                        v-model="sortStatus"
                        type="radio"
                        value="base-rate-desc"
                      />Billing Rate (High to Low)
                    </li>
                    <li class="categry2-options-li">
                      <input
                        class="mr-2 leading-tight"
                        v-model="sortStatus"
                        type="radio"
                        value="exp-asc"
                      />Experience (Low to High)
                    </li>
                    <li class="categry2-options-li">
                      <input
                        class="mr-2 leading-tight"
                        v-model="sortStatus"
                        type="radio"
                        value="exp-desc"
                      />Experience (High to Low)
                    </li>
                  </ul>
            </div>

          </div>
          </div>
         

        <div class="col-12">
          <div v-if="paginateJobs.length > 0" class="row">
            <SearchJobCard
              v-for="job in paginateJobs"
              :candidate="job"
              :key="job.id"
              :user="user"
              :total-compare="totalCompare.length"
              @calculate-rate="calculateRate"
              @refresh-jobs="fetchAPI"
              @fetch-compare="getTotalCompare"
            />
          </div>
          <div class="container" v-else >
          <h3 class="row">These are not the droids you are looking for!</h3>
          <p class="row" style="color:black;"><br>You may have a better luck searching for them if you type:<br>e.g.: US_199 for candidate ID <br>e.g.: ABAP, SAP FI, MM, Oil and Gas, Automotive for skill set and/or industry</p>
          </div>
        </div>
        <SearchPagination
          v-if="paginateJobs.length > 0"
          :pageNumber="pageNumber"
          :totalPages="totalPages"
          :minPage="minPage"
          :maxPage="maxPage"
          @change-page="setPage"
        />
      </div>

          <div v-if="totalJobs" class="col-sm-12 col-md-3 space-top">
            <ConsultantRateCalculator :calculateValue="calculateValue" />
            <doYouKnow />
          </div>

       </div>
    </div>
    <notifications group="foo" />
  </div>
</template>

<script>
import moment from "moment";
import api from "../../api/consultant";

import SearchFilter from "./SearchFilter.vue";
import SearchPagination from "./SearchPagination.vue";
import SearchJobCard from "./SearchJobCard.vue";
import ConsultantRateCalculator from "./ConsultantRateCalculator.vue";
import doYouKnow from "./doYouKnow.vue";

export default {
  props: {
    user: {
      required: false
    }
  },
  components: {
    SearchFilter,
    SearchPagination,
    SearchJobCard,
    doYouKnow
  },
  data() {
    return {
      filter: {
        filters:false,
        job_mode: [],
        job_type: [],
        category: [],
        baseRate: {
          from: null,
          to: null
        },
        work_experience: [],
        industry: [],
        state: [],
        date: [],
        available_for_contract: false,
        willing_to_travel: false,
        full_time: false,
        part_time: false,
        project: false,
        support: false
      },
      jobs: [],
      size: 15,
      pageNumber: 0,
      calculateValue: 1000,
      totalCompare: 0,
      sortStatus: null,
      isHiddenSort:true
    };
  },
  methods: {
     goToCompare(){
      window.location.href='client/add-to-compare';
    },
    fetchAPI() {
      var query = window.location.search;
      api
        .getConsultants(query || "")
        .then(res => {
          this.jobs = res.data;
        })
        .catch(err => {
          console.log(err);
        });
    },

    getTotalCompare() {
      if(this.user.role_id == 1){
        api
        .getCompareCount(this.user.id)
        .then(res => {
          this.totalCompare = res.data;
        })
        .catch(err => {
          console.log(err);
        });
      }
      else
      console.log("not logged as client");
      
    },

    setPage(page) {
      this.pageNumber = page;
    },

    calculateRate(rate) {
      this.calculateValue = rate;
    }
  },
  mounted() {
    this.fetchAPI();
    this.getTotalCompare();
  },
  computed: {
   sortLabel(){
     if(this.sortStatus == null || this.sortStatus == ""){
        return "Relevance";
     }
     if(this.sortStatus == "last-modified"){
        return "Last Modified";
     }
      if(this.sortStatus == "job-title-asc"){
        return "Job Title (A to Z)";
     }
     if(this.sortStatus == "job-title-desc"){
        return "Job Title (Z to A)";
     }
     if(this.sortStatus == "base-rate-asc"){
        return "Pay Rate (Low to High)";
     }
     if(this.sortStatus == "base-rate-desc"){
        return "Pay Rate (High to Low)";
     }
     if(this.sortStatus == "exp-asc"){
        return "Experience (Low to High)";
     }
     if(this.sortStatus == "exp-desc"){
        return "Experience (High to Low)";
     }
   },
    checkquery() {
      var param = new URLSearchParams(location.search);

      if (typeof param.get("searchterm") == "undefined" || (param.get("searchterm"))) {
        return false;
      } else {
        return true;
      }
    },
    query() {
      let param = new URLSearchParams(location.search);
      return param.get("searchterm");
    },
    filterJobs() {
      var result = this.jobs;
      for (var key in this.filter) {
        result = result.filter(job => {
          let booleanArray = [
            "available_for_contract",
            "willing_to_travel",
            "full_time",
            "part_time",
            "project",
            "support",
            "work_experience"
          ];
          if (
            !this.filter[key].length &&
            !booleanArray.includes(key) &&
            key !== "baseRate"
          )
            return true;
          //If filter category
          if (key === "category") {
            var jobCategory = job.category.split(",");
            jobCategory = jobCategory.map(job => {
              return job.toUpperCase();
            });
            //if (this.filter.category.includes(jobCategory)) return true;

            var checkDuplicate = this.filter.category.filter(cat => {
              return jobCategory.indexOf(cat) != -1;
            });

            if (checkDuplicate.length > 0) {
              return true;
            }
            return false;
          }

          if (key === "work_experience") {
            if (this.filter.work_experience.length < 1) return true;

            let shouldReturn = false;
            this.filter.work_experience.forEach(experience => {
              if (experience === "FRESH" && job.experience_in_years == 0) {
                shouldReturn = true;
              }

              if (
                experience === "1-3 YEARS" &&
                job.experience_in_years > 0 &&
                job.experience_in_years < 4
              ) {
                shouldReturn = true;
              }
              if (
                experience === "5-10 YEARS" &&
                job.experience_in_years > 4 &&
                job.experience_in_years < 11
              ) {
                shouldReturn = true;
              }

              if (experience === "10+ YEARS" && job.experience_in_years > 10) {
                shouldReturn = true;
              }
            });
            return shouldReturn;
          }

          if (booleanArray.includes(key)) {
            if (key === "work_experience") return true;
            if (this.filter[key]) {
              if (job[key] == 1) {
                return true;
              } else {
                return false;
              }
            } else {
              return true;
            }
          }

          // If base Rate
          if (key === "baseRate") {
            if ( !this.filter.baseRate.to)
              return true;
            var jobRate = parseFloat(job.base_rate);
            if (
              
              jobRate <= this.filter.baseRate.to
            ) {
              return true;
            } else {
              return false;
            }
          }

          if (key === "date") {
            var date = moment(job.availability_date);
            var today = moment(new Date());
            var differentDate = date.diff(today, "day");
            var status = false;

            this.filter.date.forEach(filterDate => {
              if (differentDate <= filterDate && differentDate > 0)
                status = true;
            });

            if (status) {
              return true;
            } else {
              return false;
            }
          }

          if (this.filter[key].includes(job[key].toUpperCase())) return true;

          return false;
        });
      }

      if (this.sortStatus == "last-modified") {
        result = result.sort((a, b) => (a.updated_at > b.updated_at ? 1 : -1));
      }

      if (this.sortStatus == "job-title-asc") {
        result = result.sort((a, b) =>
          a.sap_job_title > b.sap_job_title ? 1 : -1
        );
      }

      if (this.sortStatus == "job-title-desc") {
        result = result.sort((a, b) =>
          a.sap_job_title < b.sap_job_title ? 1 : -1
        );
      }

      if (this.sortStatus == "base-rate-asc") {
        result = result.sort((a, b) => (a.base_rate > b.base_rate ? 1 : -1));
      }

      if (this.sortStatus == "base-rate-desc") {
        result = result.sort((a, b) => (a.base_rate < b.base_rate ? 1 : -1));
      }

      if (this.sortStatus == "exp-asc") {
        result = result.sort((a, b) =>
          a.experience_in_years > b.experience_in_years ? 1 : -1
        );
      }

      if (this.sortStatus == "exp-desc") {
        result = result.sort((a, b) =>
          a.experience_in_years < b.experience_in_years ? 1 : -1
        );
      }

      return result;
    },
    paginateJobs() {
      let start = this.pageNumber * this.size;
      let end = start + this.size;
      return this.filterJobs.slice(start, end);
    },

    currentPage() {
      var jobReminder = (this.pageNumber + 1) * this.size;
      if (jobReminder > this.totalJobs) return (jobReminder = this.totalJobs);

      return jobReminder;
    },

    totalJobs() {
      return this.filterJobs.length;
    },
    totalPages() {
      return Math.ceil(this.totalJobs / this.size);
    },
    minPage() {
      return this.pageNumber + 1 !== 1;
    },
    maxPage() {
      return this.pageNumber + 1 !== this.totalPages;
    }
  },
  watch: {
    filter(val) {
      console.log(val);
    }
  }
};
</script>
<style>
.side-spacing {
  margin-left: 100px;
  margin-right: 100px;
}

.space-top {
  margin-top: 75px;
}

.container {
  padding-right: 15px;
  padding-left: 15px;
  margin-right: auto;
  margin-left: auto;
}

@media (min-width: 768) {
#wrapper .container {
  max-width: 100%;
   display: block;
  }
}

.custom-container {
margin-right: 20px;
margin-left: 20px;
} 

.color2{
  color:#3C3C3C;
}

.position1{
  margin: 20px;
}

.btncoloropen{
  font-size: 14px;
  background-color:#EF6363;
  border: 0px!important;
  font-weight: 400!important;
}
.btncolorclose{
  font-weight: 400!important;
  color:#EF6363;
  font-size: 14px;
  background-color: white!important;
  border: 2px solid;
}

.sort-btn{
  
  border:none;
  font-size:14px;
  color:black;
  background-color: transparent;
}
.reset-hover:hover{
background-color: transparent;
color:black;
}
.sort-link{
  
  color:#F78E24!important;
  text-decoration: underline;
}
.sort-link:hover{
  color: #EF6363!important;
}
</style>